require("LUBE.lua")
require("table_ster.lua")
--require("debug.lua")

function onConnect(id)
	createplayer(id)
	print("User "..id.." has connected")
end

function onReceive(data, id)
	if data == "quit" then
		onDisconnect(id)
	else
		parse(data,id)
	end
end

function onDisconnect(id)
	deleteplayer(id)
	players = players - 1
	print("User "..id.." has disconnected")
end

function love.load()
	players = 0
	connected = {}	
	connect()
end

function connect()
	server = lube.server(18025)
	server:setCallback(onReceive, onConnect, onDisconnect)
	server:setHandshake("Hi!")
end

function love.update(dt)
	server:update(dt)
	server:send( table.save( connected ) )
	love.timer.sleep(50)
end

function love.draw()
end

function createplayer(id)
	players = players + 1
	connected[id] = retinf()
end

function deleteplayer(id)
	table.remove(connected, id)
	--connected[id] = nil
end

function retinf(id)
	local x = 10
	local y = 10
	return {pos={x=x,y=y}}
end

function parse(data, id)
	if data ~= nil then
		if data == "d" then
			connected[id].pos.x = connected[id].pos.x + 1
		elseif data == "a" then
			connected[id].pos.x = connected[id].pos.x - 1
		end
	
		if data == "s" then
			connected[id].pos.y = connected[id].pos.y + 1		
		elseif data == "w" then
			connected[id].pos.y = connected[id].pos.y - 1
		end		
	end
end